extern _requestHandler

defaultRequestHandler:
        pusha
        push ds
        push es
        push fs
        push gs

        mov ax, 0x10
        mov ds, ax
        mov es, ax
        mov fs, ax
        mov gs, ax

        mov eax, esp
        push eax

        mov eax, _requestHandler
        call eax

        pop eax
        pop gs
        pop fs
        pop es
        pop ds
        popa

        add esp, 8
        iret


; Interrupt requests
global _ireq0
_ireq0:
        cli
        push byte 0
        push byte 32
        jmp defaultRequestHandler

global _ireq1
_ireq1:
        cli
        push byte 0
        push byte 33
        jmp defaultRequestHandler

global _ireq2
_ireq2:
        cli
        push byte 0
        push byte 34
        jmp defaultRequestHandler

global _ireq3
_ireq3:
        cli
        push byte 0
        push byte 35
        jmp defaultRequestHandler

global _ireq4
_ireq4:
        cli
        push byte 0
        push byte 36
        jmp defaultRequestHandler

global _ireq5
_ireq5:
        cli
        push byte 0
        push byte 37
        jmp defaultRequestHandler

global _ireq6
_ireq6:
        cli
        push byte 0
        push byte 38
        jmp defaultRequestHandler

global _ireq7
_ireq7:
        cli
        push byte 0
        push byte 39
        jmp defaultRequestHandler

global _ireq8
_ireq8:
        cli
        push byte 0
        push byte 40
        jmp defaultRequestHandler

global _ireq9
_ireq9:
        cli
        push byte 0
        push byte 41
        jmp defaultRequestHandler

global _ireq10
_ireq10:
        cli
        push byte 0
        push byte 42
        jmp defaultRequestHandler

global _ireq11
_ireq11:
        cli
        push byte 0
        push byte 43
        jmp defaultRequestHandler

global _ireq12
_ireq12:
        cli
        push byte 0
        push byte 44
        jmp defaultRequestHandler

global _ireq13
_ireq13:
        cli
        push byte 0
        push byte 45
        jmp defaultRequestHandler

global _ireq14
_ireq14:
        cli
        push byte 0
        push byte 46
        jmp defaultRequestHandler

global _ireq15
_ireq15:
        cli
        push byte 0
        push byte 47
        jmp defaultRequestHandler
