#ifndef _INTERRUPT_REQUESTS_
#define _INTERRUPT_REQUESTS_

class Idt;

class InterruptRequests {
private:
	void remapRequests();
public:
	void install(Idt &idt);

	void uninstallRequestHandler(int irq);
	void installRequestHandler(int irq, void (*handler)(struct regs *r));
};

#endif
